        .xlist
; Include file - EPOCSIBO.INC
; Epoc/Os SIBO specific include file
; Copyright (c) Psion PLC 1989-90.
;
;  VER    DATE    BY  DESCRIPTION
; ----- -------- ---- -----------
; 2.00F 30/09/90 NSM  Final release
;
EPOCSIBO_INC		equ	1
;
SupplyEnt struc
MainBatteryReading	dw	?
LithiumBatteryReading	dw	?
MainsPresent		dw	?
SupplyEnt ends
;
SupplyWarningsEnt struc
MainBatteryWarning	dw	?
LithiumBatteryWarning	dw	?
MainBatteryMaxValue	dw	?
LithiumBatteryMaxValue	dw	?
SupplyWarningsEnt ends
;
MainBatZero		equ	0
MainBatVeryLow		equ	1
MainBatLow		equ	2
MainBatGood		equ	3
;
SupplySoundWarning	equ	0001h
SupplyFlashWarning	equ	0002h
SupplySystemTimeChanged	equ	0004h
;
SupplyInfoEnt struc
SuMainBatLevel		db	?
SuMainBatStatus		db	?
SuBackupBatLevel	db	?
SuDcLevel		db	?
SuWarningFlags		dw	?
SuInsertionDate		dd	?
SuTicksInUseBattery	dd	?
SuTicksInUseDc		dd	?
SuMilliampTicks		dd	?
SupplyInfoEnt ends
;
SsdUnitInfo struc
SsdUnitStatus		db	?
SsdUnitType		db	?
SsdUnitDevices		db	?
SsdUnitAsicType		db	?
SsdUnitChanged		db	?
SsdUnitReadCmd		db	?
SsdUnitTotalSectors	dw	?
SsdUnitMask		dw	?
SsdUnitSectorsPerDevice	dw	?
SsdUnitSpare		db	?
SsdUnitShift		db	?
SsdUnitDoReadCmd	dw	?
SsdUnitInfo ends
;
SsdData struc
SsdUnitInfoBuffer SsdUnitInfo 4 dup(<>)
SsdDoorStatus	db	?
SsdDoorDelay	db	?
SsdPakCritical	db	?
SsdDoorOpened	db	?
SsdOldFrcVector dd	?
SsdFrcFlag      dw      ?
SsdPakChannel   db      ?
SsdWriteFlag	db	?
SsdFlashCount	dw	?
SsdFlashVector	dw	?
SsdFlashAddress	dw	?
SsdFlashOffset	dw	?
SsdFlashMaxProgramPulses dw ?
SsdSaveStack    dw      ?
SsdNeedSerialResume db	?
SsdBackTo4	db	?
SsdA9DoorNmiEnabled db	?
SsdSpare	db	?
SsdFlashProgram	dw	?
SsdNewPddSpareBuffer db 400h dup (?)
SsdData ends
;
        .list

